diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_whois.c ircd-hybrid-7-bg/modules/m_whois.c
--- ircd-hybrid-7rc5/modules/m_whois.c	Tue Oct 29 22:33:23 2002
+++ ircd-hybrid-7-bg/modules/m_whois.c	Sat May 24 23:27:10 2003
@@ -19,10 +19,11 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_whois.c,v 1.83 2002/10/30 03:33:23 bill Exp $
+ *  $Id: m_whois.c,v 1.4 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
+#include "fdlist.h"
 #include "tools.h"
 #include "common.h"  
 #include "handlers.h"
@@ -39,7 +40,7 @@
 #include "send.h"
 #include "list.h"
 #include "irc_string.h"
-#include "s_conf.h"
+#include "s_misc.h"
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
@@ -76,7 +77,7 @@
   mod_del_cmd(&whois_msgtab);
 }
 
-const char *_version = "$Revision: 1.83 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 /*
 ** m_whois
@@ -91,7 +92,7 @@
   
   if (parc < 2 || BadPtr(parv[1]))
   {
-    sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN),
+    sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN),
 	       me.name, parv[0]);
     return;
   }
@@ -102,7 +103,7 @@
     if((last_used + ConfigFileEntry.pace_wait_simple) > CurrentTime)
     {             
       if(MyClient(source_p))
-	sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,source_p->name);
+	sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,source_p->name);
       return;
     }
     else
@@ -138,7 +139,7 @@
   /* XXX Need BadPtr */
   if (parc < 2 || BadPtr(parv[1]))
     {
-      sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN),
+      sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN),
                  me.name, parv[0]);
       return;
     }
@@ -239,9 +240,9 @@
   }
 
   if(found)
-    sendto_one(source_p, form_str(RPL_ENDOFWHOIS), me.name, parv[0], parv[1]);
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFWHOIS), me.name, parv[0], parv[1]);
   else
-    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], nick);
+    sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK), me.name, parv[0], nick);
 
   return (0);
 }
@@ -323,10 +324,10 @@
 
   if(target_p->user == NULL)
   {
-    sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_WHOISUSER), me.name,
 	       source_p->name, name,
 	       target_p->username, target_p->host, target_p->info);
-    sendto_one(source_p, form_str(RPL_WHOISSERVER),
+    sendto_one(source_p, form_str(source_p,RPL_WHOISSERVER),
 	       me.name, source_p->name, name, "<Unknown>",
 	       "*Not On This Net*");
     return (NO);
@@ -388,12 +389,38 @@
   
   a2client_p = find_server(target_p->user->server);
           
-  sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
+  sendto_one(source_p, form_str(source_p,RPL_WHOISUSER), me.name,
 	 source_p->name, target_p->name,
 	 target_p->username, target_p->host, target_p->info);
   server_name = (char *)target_p->user->server;
 
-  ircsprintf(buf, form_str(RPL_WHOISCHANNELS),
+  if (IsOper(source_p) || (target_p == source_p))
+    sendto_one(source_p, form_str(source_p,RPL_WHOISREALHOST), me.name,
+	       source_p->name, target_p->name,
+	       ServerInfo.network_name, target_p->realhost);
+
+  if (target_p->svsflags && find_services()) 
+    {
+      t = buf; t[0] = 0;
+      
+      if (target_p->svsflags & FLAGS_SVS_IDENT)
+        { ircsprintf(t, "this nick"); t += strlen(t); }
+
+      if (target_p->svsflags & FLAGS_SVS_IDENT &&
+          target_p->svsflags & FLAGS_SVS_ADMIN)
+        { ircsprintf(t, ", "); t += strlen(t); }
+
+      if (target_p->svsflags & FLAGS_SVS_ADMIN)
+        { ircsprintf(t, "services admin"); t += strlen(t); }
+
+      sendto_one(source_p, form_str(source_p,RPL_WHOISSVSHINT), me.name,
+               source_p->name, target_p->name, buf);
+    }
+
+  if (find_z_conf(server_name) && !IsOper(source_p))
+    goto rplserver;
+
+  ircsprintf(buf, form_str(source_p,RPL_WHOISCHANNELS),
 	       me.name, source_p->name, target_p->name, "");
 
   mlen = strlen(buf);
@@ -442,28 +469,60 @@
   if (reply_to_send)
     sendto_one(source_p, "%s", buf);
           
+ rplserver:          
   if ((IsOper(source_p) || !ConfigServerHide.hide_servers) || target_p == source_p)
-    sendto_one(source_p, form_str(RPL_WHOISSERVER),
+    sendto_one(source_p, form_str(source_p,RPL_WHOISSERVER),
 	       me.name, source_p->name, target_p->name, server_name,
 	       a2client_p?a2client_p->info:"*Not On This Net*");
   else
-    sendto_one(source_p, form_str(RPL_WHOISSERVER),
+    sendto_one(source_p, form_str(source_p,RPL_WHOISSERVER),
 	       me.name, source_p->name, target_p->name,
                ServerInfo.network_name,
 	       ServerInfo.network_desc);
 
   if (target_p->user->away)
-    sendto_one(source_p, form_str(RPL_AWAY), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_AWAY), me.name,
 	       source_p->name, target_p->name, target_p->user->away);
 
   if (IsOper(target_p))
-    sendto_one(source_p, form_str(RPL_WHOISOPERATOR),
-	       me.name, source_p->name, target_p->name);
+  	{
+    	sendto_one(source_p, form_str(source_p,RPL_WHOISOPERATOR),
+	    	me.name, source_p->name, target_p->name);
+
+      	if (IsAdmin(target_p))
+        	sendto_one(source_p, form_str(source_p,RPL_WHOISADMIN),
+            	me.name, source_p->name, target_p->name);
+	}
+	
+#ifdef HAVE_LIBCRYPTO
+  if (MyClient(target_p)) {
+  	int fd = target_p->localClient->fd;
+  	fde_t *F = (fd > -1)? &fd_table[fd] : NULL;
+  	
+  	if (F && F->ssl)
+  		sendto_one(source_p, form_str(source_p,RPL_WHOISSSL),
+  			me.name, source_p->name, target_p->name);	
+  }
+#endif
+
+  if (ConfigFileEntry.cyrillic)
+    {
+      char *p;
+      for (p = target_p->name; *p; p++)
+        {
+          if ((unsigned char)*p >= 192)
+            {
+              sendto_one(source_p, form_str(source_p,RPL_WHOISCYRILLIC),
+                         me.name, source_p->name, target_p->name);
+              break;
+            }
+        }
+    }
 
   if (glob || (MyConnect(target_p) && (IsOper(source_p) ||
       !ConfigServerHide.hide_servers)) || (target_p == source_p) )
   {
-    sendto_one(source_p, form_str(RPL_WHOISIDLE),
+    sendto_one(source_p, form_str(source_p,RPL_WHOISIDLE),
 	       me.name, source_p->name, target_p->name,
 	       CurrentTime - target_p->user->last,
 	       target_p->firsttime);
@@ -498,10 +557,16 @@
   /* XXX Need BadPtr */
   if (parc < 2 || BadPtr(parv[1]))
     {
-      sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN),
+      sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN),
                  me.name, parv[0]);
       return;
     }
+    
+  if (parc > 2) {
+  
+  	cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  	cluster_prefix(client_p, parc, parv, 2, 0, 0);
+  }
 
   if(!IsClient(source_p))
     return;
@@ -524,7 +589,7 @@
       if((target_p = find_server(parv[1])) == NULL)
       {
         /* its not a server either.. theyve sent a bad whois */
-        sendto_one(source_p, form_str(ERR_NOSUCHSERVER), me.name,
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER), me.name,
 	           parv[0], parv[1]);
         return;
       }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_whowas.c ircd-hybrid-7-bg/modules/m_whowas.c
--- ircd-hybrid-7rc5/modules/m_whowas.c	Thu Aug 15 11:00:59 2002
+++ ircd-hybrid-7-bg/modules/m_whowas.c	Mon Mar 10 01:09:02 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_whowas.c,v 1.28 2002/08/15 15:00:59 adx Exp $
+ *  $Id: m_whowas.c,v 1.3 2003/03/10 06:09:02 demond Exp $
  */
 
 #include "stdinc.h"
@@ -61,7 +61,7 @@
 {
   mod_del_cmd(&whowas_msgtab);
 }
-const char *_version = "$Revision: 1.28 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 static int whowas_do(struct Client *client_p, struct Client *source_p,
                      int parc, char *parv[]);
@@ -81,14 +81,14 @@
 
   if (parc < 2)
     {
-      sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN),
+      sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN),
                  me.name, parv[0]);
       return;
     }
 
   if((last_used + ConfigFileEntry.pace_wait_simple) > CurrentTime)
     {
-      sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,source_p->name);
+      sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,source_p->name);
       return;
     }
   else
@@ -106,7 +106,7 @@
 {
   if (parc < 2)
     {
-      sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN),
+      sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN),
                  me.name, parv[0]);
       return;
     }
@@ -124,7 +124,7 @@
 
   if (parc < 2)
     {
-      sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN),
+      sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN),
                  me.name, parv[0]);
       return 0;
     }
@@ -148,18 +148,24 @@
     {
       if (!irccmp(nick, temp->name))
         {
-          sendto_one(source_p, form_str(RPL_WHOWASUSER),
+          sendto_one(source_p, form_str(source_p,RPL_WHOWASUSER),
                      me.name, parv[0], temp->name,
                      temp->username,
                      temp->hostname,
                      temp->realname);
 
+          if (IsOper(source_p))
+    		sendto_one(source_p, form_str(source_p,RPL_WHOISREALHOST), 
+    			me.name, parv[0], temp->name,
+	       		ServerInfo.network_name, 
+	       		temp->realhost);
+
           if (ConfigServerHide.hide_servers && !IsOper(source_p))
-            sendto_one(source_p, form_str(RPL_WHOISSERVER),
+            sendto_one(source_p, form_str(source_p,RPL_WHOISSERVER),
                        me.name, parv[0], temp->name,
                        ServerInfo.network_name, myctime(temp->logoff));
           else
-	    sendto_one(source_p, form_str(RPL_WHOISSERVER),
+	    	sendto_one(source_p, form_str(source_p,RPL_WHOISSERVER),
                        me.name, parv[0], temp->name,
                        temp->servername, myctime(temp->logoff));
           cur++;
@@ -169,9 +175,9 @@
         break;
     }
   if (!found)
-    sendto_one(source_p, form_str(ERR_WASNOSUCHNICK),
+    sendto_one(source_p, form_str(source_p,ERR_WASNOSUCHNICK),
                me.name, parv[0], nick);
 
-  sendto_one(source_p, form_str(RPL_ENDOFWHOWAS), me.name, parv[0], parv[1]);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFWHOWAS), me.name, parv[0], parv[1]);
   return 0;
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/servlink/README ircd-hybrid-7-bg/servlink/README
--- ircd-hybrid-7rc5/servlink/README	Sun May 27 15:57:22 2001
+++ ircd-hybrid-7-bg/servlink/README	Mon Dec 30 23:07:26 2002
@@ -1,5 +1,5 @@
 Servlink protocol documentation.
-$Id: README,v 1.4 2001/05/27 19:57:22 davidt Exp $
+$Id: README,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
 --------------
 
 After negotiating an incoming/outgoing server connection, the ircd will
diff -uNrd -x CVS ircd-hybrid-7rc5/servlink/TODO ircd-hybrid-7-bg/servlink/TODO
--- ircd-hybrid-7rc5/servlink/TODO	Sun May 27 15:57:23 2001
+++ ircd-hybrid-7-bg/servlink/TODO	Mon Dec 30 23:07:26 2002
@@ -1,5 +1,5 @@
 Servlink todo list
-$Id: TODO,v 1.5 2001/05/27 19:57:23 davidt Exp $
+$Id: TODO,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
 ------------------
 
 Fix any bugs that come up
diff -uNrd -x CVS ircd-hybrid-7rc5/servlink/control.c ircd-hybrid-7-bg/servlink/control.c
--- ircd-hybrid-7rc5/servlink/control.c	Mon Jun 11 15:19:57 2001
+++ ircd-hybrid-7-bg/servlink/control.c	Mon Dec 30 23:07:26 2002
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: control.c,v 1.4 2001/06/11 19:19:57 androsyn Exp $
+ *   $Id: control.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "setup.h"                                                   
diff -uNrd -x CVS ircd-hybrid-7rc5/servlink/control.h ircd-hybrid-7-bg/servlink/control.h
--- ircd-hybrid-7rc5/servlink/control.h	Sat May 26 19:56:46 2001
+++ ircd-hybrid-7-bg/servlink/control.h	Mon Dec 30 23:07:26 2002
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: control.h,v 1.4 2001/05/26 23:56:46 davidt Exp $
+ *   $Id: control.h,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #ifndef INCLUDED_servlink_control_h
diff -uNrd -x CVS ircd-hybrid-7rc5/servlink/io.c ircd-hybrid-7-bg/servlink/io.c
--- ircd-hybrid-7rc5/servlink/io.c	Thu Oct  4 17:22:10 2001
+++ ircd-hybrid-7-bg/servlink/io.c	Mon Dec 30 23:07:26 2002
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: io.c,v 1.28 2001/10/04 21:22:10 androsyn Exp $
+ *   $Id: io.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "setup.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/servlink/io.h ircd-hybrid-7-bg/servlink/io.h
--- ircd-hybrid-7rc5/servlink/io.h	Thu Oct  4 17:22:10 2001
+++ ircd-hybrid-7-bg/servlink/io.h	Mon Dec 30 23:07:26 2002
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: io.h,v 1.9 2001/10/04 21:22:10 androsyn Exp $
+ *   $Id: io.h,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #ifndef INCLUDED_servlink_io_h
diff -uNrd -x CVS ircd-hybrid-7rc5/servlink/servlink.c ircd-hybrid-7-bg/servlink/servlink.c
--- ircd-hybrid-7rc5/servlink/servlink.c	Thu Jul 11 23:30:01 2002
+++ ircd-hybrid-7-bg/servlink/servlink.c	Mon Dec 30 23:07:26 2002
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: servlink.c,v 1.24 2002/07/12 03:30:01 joant Exp $
+ *   $Id: servlink.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "setup.h"                                                   
diff -uNrd -x CVS ircd-hybrid-7rc5/servlink/servlink.h ircd-hybrid-7-bg/servlink/servlink.h
--- ircd-hybrid-7rc5/servlink/servlink.h	Fri Jan  4 21:15:38 2002
+++ ircd-hybrid-7-bg/servlink/servlink.h	Mon Dec 30 23:07:26 2002
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: servlink.h,v 1.20 2002/01/05 02:15:38 db Exp $
+ *   $Id: servlink.h,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #ifndef INCLUDED_servlink_servlink_h
diff -uNrd -x CVS ircd-hybrid-7rc5/src/adns.c ircd-hybrid-7-bg/src/adns.c
--- ircd-hybrid-7rc5/src/adns.c	Tue Oct 29 21:56:18 2002
+++ ircd-hybrid-7-bg/src/adns.c	Mon Mar 10 01:09:03 2003
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: adns.c,v 7.48 2002/10/30 02:56:18 androsyn Exp $
+ *  $Id: adns.c,v 1.2 2003/03/10 06:09:03 demond Exp $
  */
 
 #include "stdinc.h"
@@ -53,7 +53,7 @@
   for(x = 0; x < dns_state->nservers; x++)    
   {
     inetntop(AF_INET, &dns_state->servers[x].addr.s_addr, buf, 16);
-    sendto_one(source_p, form_str(RPL_STATSALINE), me.name, source_p->name, buf); 
+    sendto_one(source_p, form_str(source_p,RPL_STATSALINE), me.name, source_p->name, buf); 
   }
 }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/balloc.c ircd-hybrid-7-bg/src/balloc.c
--- ircd-hybrid-7rc5/src/balloc.c	Sat Aug  3 18:42:26 2002
+++ ircd-hybrid-7-bg/src/balloc.c	Thu Jan 30 10:28:59 2003
@@ -25,7 +25,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: balloc.c,v 7.38 2002/08/03 22:42:26 androsyn Exp $
+ *  $Id: balloc.c,v 1.2 2003/01/30 15:28:59 demond Exp $
  */
 
 /* 
@@ -120,7 +120,7 @@
 
   if (zero_fd < 0)
     outofmemory();
-  fd_open(zero_fd, FD_FILE, "Anonymous mmap()");
+  fd_open(zero_fd, FD_FILE, "Anonymous mmap()", NULL);
 }
 
 /*
diff -uNrd -x CVS ircd-hybrid-7rc5/src/channel.c ircd-hybrid-7-bg/src/channel.c
--- ircd-hybrid-7rc5/src/channel.c	Tue Oct 29 14:38:21 2002
+++ ircd-hybrid-7-bg/src/channel.c	Mon Mar 10 01:09:04 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel.c,v 7.342 2002/10/29 19:38:21 bill Exp $
+ *  $Id: channel.c,v 1.4 2003/03/10 06:09:04 demond Exp $
  */
 
 #include "stdinc.h"
@@ -44,7 +44,7 @@
 #include "memory.h"
 #include "balloc.h"
 #include "resv.h"
-
+#include "fdlist.h"
 
 #include "s_log.h"
 
@@ -65,6 +65,8 @@
 static int check_banned(struct Channel *chptr, struct Client *who,
                                                 char *s, char *s2);
 
+void clear_pace_queues(struct Channel *);
+
 static char buf[BUFSIZE];
 static char modebuf[MODEBUFLEN], parabuf[MODEBUFLEN];
 
@@ -254,6 +256,19 @@
     }
   }
 
+  DLINK_FOREACH_SAFE(ptr, next_ptr, who->user->repeat.head)
+  {
+	  struct Repeat *repeatptr = ptr->data;
+
+	  if (repeatptr->chptr == chptr) 
+	  {
+		  MyFree(repeatptr->text); MyFree(repeatptr);
+		  dlinkDelete(ptr, &who->user->repeat);
+		  free_dlink_node(ptr);
+		  break;
+	  }
+  }
+
   who->user->joined--;
 
 #ifdef VCHANS
@@ -287,7 +302,7 @@
   int data_to_send = 0;
   char *t;                      /* temp char pointer */
 
-  cur_len = mlen = ircsprintf(buf, ":%s SJOIN %lu %s %s %s:", me.name,
+  cur_len = mlen = ircsprintf(buf, ":%s SJOIN %lu %s %s %s :", me.name,
                    (unsigned long)chptr->channelts,
                    chptr->chname, lmodebuf, lparabuf);
 
@@ -358,11 +373,17 @@
 
   send_mode_list(client_p, chptr->chname, &chptr->banlist, 'b', 0);
 
+  if (IsCapable(client_p, CAP_DENY))
+    send_mode_list(client_p, chptr->chname, &chptr->denylist, 'd', 0);
+
   if (IsCapable(client_p, CAP_EX))
     send_mode_list(client_p, chptr->chname, &chptr->exceptlist, 'e', 0);
 
   if (IsCapable(client_p, CAP_IE))
     send_mode_list(client_p, chptr->chname, &chptr->invexlist, 'I', 0);
+
+  if (IsCapable(client_p, CAP_SW))
+    send_mode_list(client_p, chptr->chname, &chptr->substlist, 'w', 0);
 }
 
 /*
@@ -373,7 +394,7 @@
  *              - char flag flagging type of mode i.e. 'b' 'e' etc.
  *              - clear (remove all current modes, for ophiding, etc)
  * output       - NONE
- * side effects - sends +b/+e/+I
+ * side effects - sends +b/+e/+w/+I
  *
  */
 static void
@@ -428,6 +449,45 @@
     sendto_one(client_p, "%s%s %s", buf, mbuf, pbuf);
 }
 
+void
+clear_pace_queues(struct Channel *chptr)
+{
+  struct Pace *pace;
+
+  while (chptr->joint)
+    {
+      pace = chptr->joint;
+      chptr->joint = pace->next;
+      MyFree(pace);
+    }
+  chptr->joinh = NULL; chptr->joins = 0;
+
+  while (chptr->partt)
+    {
+      pace = chptr->partt;
+      chptr->partt = pace->next;
+      MyFree(pace);
+    }
+  chptr->parth = NULL; chptr->parts = 0;
+
+  while (chptr->msgt)
+    {
+      pace = chptr->msgt;
+      chptr->msgt = pace->next;
+      MyFree(pace->text);
+      MyFree(pace);
+    }
+  chptr->msgh = NULL; chptr->msgs = 0;
+  
+  while (chptr->sendt)
+    {
+      pace = chptr->sendt;
+      chptr->sendt = pace->next;
+      MyFree(pace->text);
+      MyFree(pace);
+    }
+  chptr->sendh = NULL; chptr->sends = 0;
+}
 
 /*
  * check_channel_name
@@ -572,13 +632,16 @@
   free_channel_list(&chptr->banlist);
   free_channel_list(&chptr->exceptlist);
   free_channel_list(&chptr->invexlist);
+  free_channel_list(&chptr->substlist);
 
   /* Free the topic */
   free_topic(chptr);
   /* This should be redundant at this point but JIC */
-  chptr->banlist.head = chptr->exceptlist.head = chptr->invexlist.head = NULL;
+  chptr->banlist.head = chptr->exceptlist.head = 
+  chptr->invexlist.head = chptr->substlist.head = NULL;
 
-  chptr->banlist.tail = chptr->exceptlist.tail = chptr->invexlist.tail = NULL;
+  chptr->banlist.tail = chptr->exceptlist.tail = 
+  chptr->invexlist.tail = chptr->substlist.tail = NULL;
 
   if (chptr->prevch)
     chptr->prevch->nextch = chptr->nextch;
@@ -587,6 +650,7 @@
   if (chptr->nextch)
     chptr->nextch->prevch = chptr->prevch;
 
+  clear_pace_queues(chptr);
 
   del_from_channel_hash_table(chptr->chname, chptr);
   if (ServerInfo.hub == 1)
@@ -685,7 +749,7 @@
   /* Find users on same channel (defined by chptr) */
   if (ShowChannel(source_p, chptr))
   {
-    ircsprintf(lbuf, form_str(RPL_NAMREPLY),
+    ircsprintf(lbuf, form_str(source_p,RPL_NAMREPLY),
                me.name, source_p->name, channel_pub_or_secret(chptr));
     mlen = strlen(lbuf);
     ircsprintf(lbuf + mlen, " %s :", name_of_channel);
@@ -761,7 +825,7 @@
   }
 
   if (show_eon)
-    sendto_one(source_p, form_str(RPL_ENDOFNAMES), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFNAMES), me.name,
                source_p->name, name_of_channel);
 }
 #else
@@ -795,7 +859,7 @@
 
     set_channel_mode_flags(ptr_flags, chptr, source_p);
     is_member = IsMember(source_p, chptr);
-    ircsprintf(lbuf, form_str(RPL_NAMREPLY),
+    ircsprintf(lbuf, form_str(source_p,RPL_NAMREPLY),
 	       me.name, source_p->name, channel_pub_or_secret(chptr));
 
     mlen = strlen(lbuf);
@@ -835,12 +899,11 @@
   }
 
   if(show_eon)
-    sendto_one(source_p, form_str(RPL_ENDOFNAMES), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFNAMES), me.name,
 	       source_p->name, name_of_channel);
 }
 #endif /* ANONOPS */     
       
-
 /*
  * channel_pub_or_secret
  *
@@ -1006,8 +1069,12 @@
 {
   dlink_node *ban;
   dlink_node *except;
+  dlink_node *deny;
   struct Ban *actualBan = NULL;
   struct Ban *actualExcept = NULL;
+  struct Ban *actualDeny = NULL;
+  struct Channel *mychptr;
+  dlink_node *chan;
 
   DLINK_FOREACH(ban, chptr->banlist.head)
   {
@@ -1020,7 +1087,23 @@
       actualBan = NULL;
   }
 
-  if ((actualBan != NULL) && ConfigChannel.use_except)
+  DLINK_FOREACH(deny, chptr->denylist.head)
+  {
+    actualDeny = deny->data;
+    if (match(actualDeny->banstr, who->info))
+    	break;
+    if (IsPerson(who))
+    DLINK_FOREACH(chan, who->user->channel.head)
+    {
+    	mychptr = chan->data;
+    	if (match(actualDeny->banstr, mychptr->chname))
+    		goto brk;
+    }
+    actualDeny = NULL;
+  }
+brk:
+
+  if ((actualBan || actualDeny) && ConfigChannel.use_except)
   {
     DLINK_FOREACH(except, chptr->exceptlist.head)
     {
@@ -1035,7 +1118,7 @@
     }
   }
 
-  return ((actualBan ? CHFL_BAN : 0));
+  return ((actualBan ? CHFL_BAN : (actualDeny ? CHFL_DENY : 0)));
 }
 
 /* small series of "helper" functions */
@@ -1055,6 +1138,7 @@
   struct Ban *invex = NULL;
   char src_host[NICKLEN + USERLEN + HOSTLEN + 6];
   char src_iphost[NICKLEN + USERLEN + HOSTLEN + 6];
+  int banned;
 
   assert(source_p->localClient != NULL);
 
@@ -1063,8 +1147,11 @@
   ircsprintf(src_iphost,"%s!%s@%s", source_p->name, source_p->username,
 	     source_p->localClient->sockhost);
 
-  if ((check_banned(chptr, source_p, src_host, src_iphost)) == CHFL_BAN)
+  banned = check_banned(chptr, source_p, src_host, src_iphost);
+  if (banned == CHFL_BAN)
     return (ERR_BANNEDFROMCHAN);
+  else if (banned == CHFL_DENY)
+  	return (ERR_DENIEDFROMCHAN);
 
   if (chptr->mode.mode & MODE_INVITEONLY)
   {
@@ -1094,6 +1181,37 @@
   if (chptr->mode.limit && chptr->users >= chptr->mode.limit)
     return (ERR_CHANNELISFULL);
 
+  if (RegNicksOnlyChannel(chptr) && !(source_p->svsflags & FLAGS_SVS_IDENT))
+    return (ERR_REGNICKSCHAN);
+
+  if (ConfigFileEntry.cyrillic && NoCyrNicksChannel(chptr))
+  {
+    char *p;
+    for (p = source_p->name; *p; p++)
+	{
+	  if ((unsigned char)*p >= 192)
+	  {
+	    return (ERR_NOCYRNICKCHAN);
+	    break;
+	  }
+	}
+  }
+  
+  if (SSLonlyChannel(chptr)) 
+  {
+#ifdef HAVE_LIBCRYPTO
+  	if (MyClient(source_p)) {
+  		int fd = source_p->localClient->fd;
+  		fde_t *F = (fd > -1)? &fd_table[fd] : NULL;
+  	
+  		if (F && !F->ssl)
+  			return (ERR_SSLONLYCHAN);
+  	}
+#else
+	return (ERR_SSLONLYCHAN);	/* deny everyone on a non SSL-enabled server */
+#endif  
+  }
+
   return 0;
 }
 
@@ -1192,7 +1310,6 @@
   return (0);
 }
 
-
 /*
  * can_send
  *
@@ -1222,8 +1339,11 @@
   if (chptr->mode.mode & MODE_MODERATED)
     return (CAN_SEND_NO);
 
+  if (RegsMaySpeakChannel(chptr) && !(source_p->svsflags & FLAGS_SVS_IDENT))
+    return CAN_SEND_NOTREG;
+  
   if (ConfigChannel.quiet_on_ban && MyClient(source_p) &&
-      (is_banned(chptr, source_p) == CHFL_BAN))
+      (is_banned(chptr, source_p) & (CHFL_BAN|CHFL_DENY)))
   {
     return (CAN_SEND_NO);
   }
@@ -1399,3 +1519,171 @@
   }
 }
 
+/*
+ * add to channel pace queues, join or part
+ *									-demond
+ */
+void add_pace(struct Channel *chptr, struct Client *client_p, 
+		      char *chname, int join, int shownames)
+{
+  struct Pace *pace = MyMalloc(sizeof(struct Pace) + strlen(chname));
+
+  strcpy(pace->nick, client_p->name);
+  strcpy(pace->user, client_p->username);
+  strcpy(pace->host, client_p->host);
+  strcpy(pace->chan, chname);
+
+  pace->next = NULL;
+  pace->shownames = shownames;
+
+  if (join)
+    {
+      if (chptr->joinh)
+		chptr->joinh->next = pace;
+      chptr->joinh = pace;
+      if (!chptr->joint)
+		chptr->joint = pace;
+
+      chptr->joins++;
+    }
+  else
+    {
+      if (chptr->parth)
+		chptr->parth->next = pace;
+      chptr->parth = pace;
+      if (!chptr->partt)
+		chptr->partt = pace;
+
+      chptr->parts++;
+    }
+}
+
+/*
+ * add to channel PRIVMSG/NOTICE pace queue
+ *									-demond										
+ */
+void add_pace_msg(struct Channel *chptr, 
+		  struct Client *client_p, struct Client *source_p,
+		  char *command, char *text)
+{
+  struct Pace *pace = MyMalloc(sizeof(struct Pace) + strlen(chptr->chname));
+
+  strcpy(pace->nick, command);
+  strcpy(pace->user, client_p? client_p->name : "can this be NULL?");
+  strcpy(pace->host, source_p->name);
+  strcpy(pace->chan, chptr->chname);
+
+  pace->next = NULL;
+  pace->text = MyMalloc(strlen(text) + 1);
+  strcpy(pace->text, text);
+
+  if (chptr->msgh)
+    chptr->msgh->next = pace;
+  chptr->msgh = pace;
+  if (!chptr->msgt)
+    chptr->msgt = pace;
+
+  chptr->msgs++;
+}
+
+/*
+ * this will flush out pace queues every PACE_CHANNELS_TIME secs
+ *														-demond
+ */
+void pace_channels(void *blah)
+{
+  struct Channel *chptr;
+
+  for (chptr = GlobalChannelList; chptr; chptr = chptr->nextch)
+    {
+      if (!PaceChannel(chptr))
+		continue;
+
+      if (chptr->joins)
+		{
+	  		struct Pace *pace = chptr->joint;
+	  		struct Client *client_p = find_client(pace->nick);
+
+	  		sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+			   pace->nick,
+			   pace->user,
+			   pace->host,
+			   pace->chan);
+	  		if (client_p && pace->shownames)
+	    		channel_member_names(client_p, chptr, pace->chan, 1);
+
+	  		chptr->joint = pace->next;
+	  		if (!pace->next)
+	    		chptr->joinh = NULL;
+	  		MyFree(pace);
+
+	  		chptr->joins--;
+		}
+
+      if (chptr->parts)
+		{
+	  		struct Pace *pace = chptr->partt;
+	  		struct Client *client_p = find_client(pace->nick);
+
+	  		sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s PART :%s",
+			   pace->nick,
+			   pace->user,
+			   pace->host,
+			   pace->chan);
+	  		if (client_p)
+	    		sendto_one(client_p, ":%s!%s@%s PART :%s",
+			   		pace->nick,
+			   		pace->user,
+			   		pace->host,
+			   		pace->chan);
+
+	  		chptr->partt = pace->next;
+	  		if (!pace->next)
+	    		chptr->parth = NULL;
+	  		MyFree(pace);
+
+	  		chptr->parts--;
+		}
+
+      if (chptr->msgs)
+		{
+	  		struct Pace *pace = chptr->msgt;
+	  		struct Client *client_p = find_client(pace->user);
+	  		struct Client *source_p = find_client(pace->host);
+	  		struct Channel *vchan = hash_find_channel(pace->chan);
+
+	  		if (client_p && source_p && vchan)
+	    		sendto_channel_butone(client_p, source_p, vchan,
+                                  pace->nick, ":%s", pace->text);
+
+	  		chptr->msgt = pace->next;
+	  		if (!pace->next)
+	    		chptr->msgh = NULL;
+	  		MyFree(pace->text);
+	  		MyFree(pace);
+
+	  		chptr->msgs--;
+		}
+
+      if (chptr->sends)
+		{
+	  		struct Pace *pace = chptr->sendt;
+	  		struct Channel *vchan = hash_find_channel(pace->chan);
+
+	  		if (vchan)
+	    		sendto_chanlists_local(vchan, pace->text, pace->shownames);
+
+	  		chptr->sendt = pace->next;
+	  		if (!pace->next)
+	    		chptr->sendh = NULL;
+	  		MyFree(pace->text);
+	  		MyFree(pace);
+
+	  		chptr->sends--;
+		}
+    }
+
+  /* autorescheduled 
+  eventAdd("pace_channels", pace_channels, NULL, PACE_CHANNELS_TIME);
+  */
+}
